#define _POSIX_C_SOURCE 1
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "caracteristiques.h"


static void parcours(char *nom_rep);


int  main(int argc, char *argv[]){
  int i;
  for(i=1;i < argc;i++){
    parcours(argv[i]);
  }
  return EXIT_SUCCESS;
}

/******************************************************
 * parcours recoit le nom de repertoire en arguments
 *****************************************************/
static void parcours(char *nom_rep){
  /*  struct stat caracteristiques;*/
#define TAILLE_TAMPON 256
  char tampon[TAILLE_TAMPON];
  char chemin[1024];

  DIR *flot;
  int ligne;

  if((flot = opendir(nom_rep))==NULL){
    perror(nom_rep);
    return;
  }

  for (;;){
    struct dirent *entree;
    errno = 0;
    entree = readdir(flot);
    if (entree == NULL){
      if (errno != 0)
	perror(nom_rep);
      closedir(flot);
      break;
    }
    /* on ne traite ni . ni .. */
    if (strcmp(entree->d_name, ".") == 0
	|| strcmp(entree->d_name, "..") == 0)
      continue;

    sprintf(chemin,"%s/%s",nom_rep,entree->d_name);

    ligne=caracteristiques(chemin, tampon, TAILLE_TAMPON);
    if(ligne == 0){
      printf("%s\n",tampon);
    }
    else if(ligne == -1){
      fprintf(stderr,"%s : tampon trop petit\n","parcours");
    }
  }
}


